module xorshiftplus(clock, reset, seed, out);
// XORSHIFT128+ volgens http://xorshift.di.unimi.it/xorshift128plus.c, 
// als ik de C-code goed heb vertaald.
// XORSHIFT128+ according to http://xorshift.di.unimi.it/xorshift128plus.c, 
// if I translated the C-code properly.
input clock, reset;
input [63:0] seed;
output [63:0] out;
reg [63:0] x;
reg [63:0] y;
reg [63:0] a;
reg [63:0] b;
reg [63:0] c;
reg [86:0] hulp1;
reg [63:0] hulp2;
reg [63:0] hulp3;
always @ (posedge clock)
begin
	if (reset)
	begin
		x <= seed;
		y <= seed;
	end
	else
	begin
		x <= y;
		y <= c + y;
	end
end
always @ *
begin
	hulp1 = x << 23;
	a = x ^ hulp1[63:0];
	hulp2 = a >> 17;
	b = a ^ hulp2[63:0];
	hulp3 = y >> 26;
	c = b ^ y ^ hulp3[63:0];
end
assign out = y; // gepijplijnd door stiekem niet c + y te doen
// pipelined by not taking c + y.
endmodule
